# Template-content structure

This is the official code for the paper "Explaining the Complex Task Reasoning of Large Language Models with Template-Content Structure".

The package dependents are listed in `requirements.txt`. Here we recommand to use `pip` to install the packages to avoid the version conflicts. 

## dataset
We use two dataset: `concat-the-last-letter` and `singleEQ`, which are in the `concat_dataset` and `singleeq_dataset` respectively. The generating file is also in the corresponding folder: `concat_dataset/data_generate.py` and `singleeq_dataset/data_generate.py`.

## experiment code
The most of our code is in `generate.py`. In this file, we define a Generator and TextProcess class to encapsulate the code for generation and testing using different language models. 

To reproduce our experiments, you can run the `variance.py` for the variance experiments in Sec 6.1 and `tc_classify.py` for the classification experiments in Sec 6.2.

Notice that if you want to use the `Llama-2` models, you need to **request the access** following the instruction in [Llama-2](https://huggingface.co/meta-llama). Once you have the access, you can create your user access token and paste the token in the `huggingface_auth_token` file.